//i2s very simple audio driver
//Ivan Gorodetsky 2015
module audio(
input mainClk,
input reset,
input [11:0] left,
input [11:0] right,
output AUD_XCK,
output AUD_BCLK,
output AUD_DACLRCK,
output AUD_ADCLRCK,
output AUD_DACDAT,
input AUD_ADCDAT
);


reg[31:0] dacbuf;
reg[2:0] clkDiv;
reg[4:0] bitcount;


reg [15:0] fxphacc;
always @(posedge mainClk) fxphacc <= fxphacc+16'd9587;//12.288 from 84 Mhz

assign AUD_XCK = fxphacc[15];
assign AUD_BCLK = reset ? 1'bZ : clkDiv[2];
assign AUD_DACLRCK = reset ? 1'b0 : bitcount>=5'd0&&bitcount<=5'd15;
assign AUD_ADCLRCK = reset ? 1'b0 : bitcount>=5'd0&&bitcount<=5'd15;
assign AUD_DACDAT = reset ? 1'b0 : dacbuf[bitcount];

always @(posedge AUD_XCK) clkDiv<=clkDiv+1;

always @(negedge AUD_BCLK or posedge reset)
 if(reset==1'b1) bitcount<=5'd0;
 else begin
  if(bitcount==5'd31) begin
	dacbuf<={1'b0,left[11:0],4'b0,right[11:0],3'b0};
  end
  bitcount<=bitcount-1;
 end


endmodule