
//Main credits in tsconf.vhd
//top for tsconf on DE1 Ivan Gorodetsky 15.03.2015

module tsconf_top(
			////////////////////	Clock Input	 	////////////////////	 
		CLOCK_24,						//	24 MHz
		////////////////////	Push Button		////////////////////
		KEY,							//	Pushbutton[3:0]
		/////////////////////	SDRAM Interface		////////////////
		DRAM_DQ,						//	SDRAM Data bus 16 Bits
		DRAM_ADDR,						//	SDRAM Address bus 12 Bits
		DRAM_LDQM,						//	SDRAM Low-byte Data Mask 
		DRAM_UDQM,						//	SDRAM High-byte Data Mask
		DRAM_WE_N,						//	SDRAM Write Enable
		DRAM_CAS_N,						//	SDRAM Column Address Strobe
		DRAM_RAS_N,						//	SDRAM Row Address Strobe
		DRAM_CS_N,						//	SDRAM Chip Select
		DRAM_BA_0,						//	SDRAM Bank Address 0
		DRAM_BA_1,						//	SDRAM Bank Address 0
		DRAM_CLK,						//	SDRAM Clock
		DRAM_CKE,						//	SDRAM Clock Enable
		////////////////////	SD_Card Interface	////////////////
		SD_DAT,							//	SD Card Data
		SD_DAT3,						//	SD Card Data 3
		SD_CMD,							//	SD Card Command Signal
		SD_CLK,							//	SD Card Clock
		////////////////////	I2C		////////////////////////////
		I2C_SDAT,						//	I2C Data
		I2C_SCLK,						//	I2C Clock
		////////////////////	PS2		////////////////////////////
		PS2_DAT,						//	PS2 Data
		PS2_CLK,						//	PS2 Clock
		////////////////////	VGA		////////////////////////////
		VGA_HS,							//	VGA H_SYNC
		VGA_VS,							//	VGA V_SYNC
		VGA_R,   						//	VGA Red[3:0]
		VGA_G,	 						//	VGA Green[3:0]
		VGA_B,  						//	VGA Blue[3:0]
		////////////////	Audio CODEC		////////////////////////
		AUD_ADCLRCK,					//	Audio CODEC ADC LR Clock
		AUD_ADCDAT,						//	Audio CODEC ADC Data
		AUD_DACLRCK,					//	Audio CODEC DAC LR Clock
		AUD_DACDAT,						//	Audio CODEC DAC Data
		AUD_BCLK,						//	Audio CODEC Bit-Stream Clock
		AUD_XCK,						//	Audio CODEC Chip Clock
	);

////////////////////////	Clock Input	 	////////////////////////
input	[1:0]	CLOCK_24;				//	24 MHz
////////////////////////	Push Button		////////////////////////
input	[3:0]	KEY;					//	Pushbutton[3:0]
///////////////////////		SDRAM Interface	////////////////////////
inout	[15:0]	DRAM_DQ;				//	SDRAM Data bus 16 Bits
output	[11:0]	DRAM_ADDR;				//	SDRAM Address bus 12 Bits
output			DRAM_LDQM;				//	SDRAM Low-byte Data Mask 
output			DRAM_UDQM;				//	SDRAM High-byte Data Mask
output			DRAM_WE_N;				//	SDRAM Write Enable
output			DRAM_CAS_N;				//	SDRAM Column Address Strobe
output			DRAM_RAS_N;				//	SDRAM Row Address Strobe
output			DRAM_CS_N;				//	SDRAM Chip Select
output			DRAM_BA_0;				//	SDRAM Bank Address 0
output			DRAM_BA_1;				//	SDRAM Bank Address 0
output			DRAM_CLK;				//	SDRAM Clock
output			DRAM_CKE;				//	SDRAM Clock Enable
////////////////////	SD Card Interface	////////////////////////
inout			SD_DAT;					//	SD Card Data
inout			SD_DAT3;				//	SD Card Data 3
inout			SD_CMD;					//	SD Card Command Signal
output			SD_CLK;					//	SD Card Clock
////////////////////////	I2C		////////////////////////////////
inout			I2C_SDAT;				//	I2C Data
output			I2C_SCLK;				//	I2C Clock
////////////////////////	PS2		////////////////////////////////
inout		 	PS2_DAT;				//	PS2 Data
inout			PS2_CLK;				//	PS2 Clock
////////////////////////	VGA			////////////////////////////
output			VGA_HS;					//	VGA H_SYNC
output			VGA_VS;					//	VGA V_SYNC
output	[3:0]	VGA_R;   				//	VGA Red[3:0]
output	[3:0]	VGA_G;	 				//	VGA Green[3:0]
output	[3:0]	VGA_B;   				//	VGA Blue[3:0]
////////////////////	Audio CODEC		////////////////////////////
inout			AUD_ADCLRCK;			//	Audio CODEC ADC LR Clock
input			AUD_ADCDAT;				//	Audio CODEC ADC Data
inout			AUD_DACLRCK;			//	Audio CODEC DAC LR Clock
output			AUD_DACDAT;				//	Audio CODEC DAC Data
inout			AUD_BCLK;				//	Audio CODEC Bit-Stream Clock
output			AUD_XCK;	

`default_nettype none

wire reset;
wire [7:0] red,green,blue;
wire [11:0] snd_l,snd_r;
tsconf (
	.CLK(CLOCK_24[0]),

	.SDRAM_DQ(DRAM_DQ),
	.SDRAM_A(DRAM_ADDR),
	.SDRAM_BA({DRAM_BA_1,DRAM_BA_0}),
	.SDRAM_CLK(DRAM_CLK),
	.SDRAM_DQML(DRAM_LDQM),
	.SDRAM_DQMH(DRAM_UDQM),
	.SDRAM_WE_N(DRAM_WE_N),
	.SDRAM_CAS_N(DRAM_CAS_N),
	.SDRAM_RAS_N(DRAM_RAS_N),
	.SDRAM_CKE(DRAM_CKE),
	.SDRAM_CS_N(DRAM_CS_N),

	.VGA_R(red),
	.VGA_G(green),
	.VGA_B(blue),
	.VGA_HS(VGA_HS),
	.VGA_VS(VGA_VS),

	.PS2_CLK(PS2_CLK),
	.PS2_DAT(PS2_DAT),

	.SD_SO(SD_DAT),
	.SD_SI(SD_CMD),
	.SD_CLK(SD_CLK),
	.SD_CS_N(SD_DAT3),

	.KEYS(KEY[3:0]),
	
	.SOUND_L(snd_l),
	.SOUND_R(snd_r),
	.RESET_OUT(reset),
	);
assign VGA_R[3:0]=red[7:4];
assign VGA_G[3:0]=green[7:4];
assign VGA_B[3:0]=blue[7:4];


I2C_AV_Config (	.iCLK(CLOCK_24[0]),
						.iRST_N(~reset),
						.I2C_SCLK(I2C_SCLK),
						.I2C_SDAT(I2C_SDAT)	);

audio(
.mainClk(DRAM_CLK),
.reset(reset),
.left(snd_l),
.right(snd_r),
.AUD_XCK(AUD_XCK),
.AUD_BCLK(AUD_BCLK),
.AUD_DACLRCK(AUD_DACLRCK),
.AUD_ADCLRCK(AUD_ADCLRCK),
.AUD_DACDAT(AUD_DACDAT),
.AUD_ADCDAT(AUD_ADCDAT)
);


endmodule
